class Integer

	def seeable_chr
		c = self & 0xFF
		c < 0x20 ? '.' : (c < 0x7f ? c.chr : '.')
	end
end

class Ndump16

	def initialize(adr = 0)
		@sep = "\n#Adr.     +0   +1   +2   +3   +4   +5   +6   +7 'Character\n"
		@adr = adr >> 1
		@chr = ''
	end

	def <<(c)
		rep = ''
		rep += @sep if(@adr % 128 == 0)
		rep += sprintf('#%04X = ', @adr) if(@adr % 8 == 0)
		rep += c ? sprintf('%04X ', c & 0xFFFF) : '     '
		@chr += c ? ((c >> 8).seeable_chr + c.seeable_chr) : '  '
		rep += "'#{@chr}\n" and @chr = '' if(@adr % 8 == 7)
		@adr += 1
		rep
	end

	def tail
		rep = ''
		rep += (self << nil) until(@adr % 8 == 0)
		rep
	end
end

class Ndump16headless

	def initialize(adr = 0)
		@sep = "\n#Adr.   +0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F 'Character\n"
		@adr = adr >> 1
		@chr = ''
	end

	def <<(c)
		rep = ''
		rep += @sep if(@adr % 256 == 0)
		rep += sprintf('#%04X = ', @adr) if(@adr % 16 == 0)
		rep += c ? sprintf('%02X ', c & 0xFF) : '   '
		@chr += c ? c.seeable_chr : '  '
		rep += "'#{@chr}\n" and @chr = '' if(@adr % 16 == 15)
		@adr += 1
		rep
	end

	def tail
		rep = ''
		rep += (self << nil) until(@adr % 16 == 0)
		rep
	end
end

